Index: NEWS
===================================================================
--- NEWS	(revision 1077)
+++ NEWS	(revision 1080)
@@ -1,11 +1,18 @@
-2011-08-08 Version 1.0.7 released
-
-        Release series 1.0 has reached its end of life. This is the last
-        bugfix release in that series.
-
-        #382: Allow lgf files without Arc maps
+2011-08-08 Version 1.1.4 released
+
+        Bugfix release.
+
         #392: Bug fix in Dfs::start(s,t)
-
-2010-10-21 Version 1.0.6 released
+        #414: Fix wrong initialization in Preflow
+        #404: Update Doxygen configuration
+        #416: Support tests with valgrind
+        #418: Better Win CodeBlock/MinGW support
+        #419: Backport build environment improvements from the main branch
+              - Build of mip_test and lp_test precede the running of the tests
+              - Also search for coin libs under ${COIN_ROOT_DIR}/lib/coin
+              - Do not look for COIN_VOL libraries
+        #382: Allow lgf file without Arc maps
+        
+2010-10-21 Version 1.1.3 released
 
         Bugfix release.
@@ -15,23 +22,130 @@
               The target graph is cleared before adding nodes and arcs/edges.
 
-
-2010-03-08 Version 1.0.5 released
-
-        Bugfix release.
-
+        #356: Fix multiple execution bug in weighted matchings
+        #364: Add missing UndirectedTags
+        #368: Fix the usage of std::numeric_limits<>::min() in Network Simplex
+        #372: Fix a critical bug in preflow
+
+2010-03-08 Version 1.1.2 released
+
+        Bugfix release.
+
+        #317: Fix (and improve) error message in mip_test.cc
+              Remove unnecessary OsiCbc dependency
         #250: Fix in pathSource() and pathTarget()
+        #322: Distribute LEMONConfig.cmake.in
         #321: Use pathCopy(from,to) instead of copyPath(to,from)
         #330: Bug fix in map_extender.h
-        #335: Fix clear() function in ExtendFindEnum (#335)
+        #335: Fix clear() function in ExtendFindEnum
+        #337: Use void* as LPX object pointer
         #336: Fix the date field comment of graphToEps() output
-
-2009-05-05 Version 1.0.4 released
-
-        Bugfix release.
-
-        #274,#280: Install lemon/config.h and fix its bad include by core.h
-        #275: Prefix macro names with LEMON_ in lemon/config.h
-        ----: Small script for making the release tarballs added
-        ----: Minor improvement in unify-sources.sh (a76f55d7d397)
+        #323: Bug fix in Suurballe
+
+2009-10-03 Version 1.1.1 released
+
+        Bugfix release.
+
+        #295: Suppress MSVC warnings using pragmas
+        ----: Various CMAKE related improvements
+              * Remove duplications from doc/CMakeLists.txt
+              * Rename documentation install folder from 'docs' to 'html'
+              * Add tools/CMakeLists.txt to the tarball
+              * Generate and install LEMONConfig.cmake
+              * Change the label of the html project in Visual Studio
+              * Fix the check for the 'long long' type
+              * Put the version string into config.h
+              * Minor CMake improvements
+              * Set the version to 'hg-tip' if everything fails
+        #311: Add missing 'explicit' keywords
+        #302: Fix the implementation and doc of CrossRefMap
+        #308: Remove duplicate list_graph.h entry from source list
+        #307: Bug fix in Preflow and Circulation
+
+2009-05-13 Version 1.1 released
+
+        This is the second stable release of the 1.x series. It
+        features a better coverage of the tools available in the 0.x
+        series, a thoroughly reworked LP/MIP interface plus various
+        improvements in the existing tools.
+
+        * Much improved M$ Windows support
+          * Various improvements in the CMAKE build system
+          * Compilation warnings are fixed/suppressed
+        * Support IBM xlC compiler
+        * New algorithms
+          * Connectivity related algorithms (#61)
+          * Euler walks (#65)
+          * Preflow push-relabel max. flow algorithm (#176)
+          * Circulation algorithm (push-relabel based) (#175)
+          * Suurballe algorithm (#47)
+          * Gomory-Hu algorithm (#66)
+          * Hao-Orlin algorithm (#58)
+          * Edmond's maximum cardinality and weighted matching algorithms
+            in general graphs (#48,#265)
+          * Minimum cost arborescence/branching (#60)
+          * Network Simplex min. cost flow algorithm (#234)
+        * New data structures
+          * Full graph structure (#57)
+          * Grid graph structure (#57)
+          * Hypercube graph structure (#57)
+          * Graph adaptors (#67)
+          * ArcSet and EdgeSet classes (#67)
+          * Elevator class (#174)
+        * Other new tools
+          * LP/MIP interface (#44)
+            * Support for GLPK, CPLEX, Soplex, COIN-OR CLP and CBC
+          * Reader for the Nauty file format (#55)
+          * DIMACS readers (#167)
+          * Radix sort algorithms (#72)
+          * RangeIdMap and CrossRefMap (#160)
+        * New command line tools
+          * DIMACS to LGF converter (#182)
+          * lgf-gen - a graph generator (#45)
+          * DIMACS solver utility (#226)
+        * Other code improvements
+          * Lognormal distribution added to Random (#102)
+          * Better (i.e. O(1) time) item counting in SmartGraph (#3)
+          * The standard maps of graphs are guaranteed to be
+            reference maps (#190)
+        * Miscellaneous
+          * Various doc improvements
+          * Improved 0.x -> 1.x converter script
+
+        * Several bugfixes (compared to release 1.0):
+          #170: Bugfix SmartDigraph::split()
+          #171: Bugfix in SmartGraph::restoreSnapshot()
+          #172: Extended test cases for graphs and digraphs
+          #173: Bugfix in Random
+                * operator()s always return a double now
+                * the faulty real<Num>(Num) and real<Num>(Num,Num)
+                  have been removed
+          #187: Remove DijkstraWidestPathOperationTraits
+          #61:  Bugfix in DfsVisit
+          #193: Bugfix in GraphReader::skipSection()
+          #195: Bugfix in ConEdgeIt()
+          #197: Bugfix in heap unionfind
+                * This bug affects Edmond's general matching algorithms
+          #207: Fix 'make install' without 'make html' using CMAKE
+          #208: Suppress or fix VS2008 compilation warnings
+          ----: Update the LEMON icon
+          ----: Enable the component-based installer
+                (in installers made by CPACK)
+          ----: Set the proper version for CMAKE in the tarballs
+                (made by autotools)
+          ----: Minor clarification in the LICENSE file
+          ----: Add missing unistd.h include to time_measure.h
+          #204: Compilation bug fixed in graph_to_eps.h with VS2005
+          #214,#215: windows.h should never be included by lemon headers
+          #230: Build systems check the availability of 'long long' type
+          #229: Default implementation of Tolerance<> is used for integer types
+          #211,#212: Various fixes for compiling on AIX
+          ----: Improvements in CMAKE config
+                - docs is installed in share/doc/
+                - detects newer versions of Ghostscript
+          #239: Fix missing 'inline' specifier in time_measure.h
+          #274,#280: Install lemon/config.h
+          #275: Prefix macro names with LEMON_ in lemon/config.h
+          ----: Small script for making the release tarballs added
+          ----: Minor improvement in unify-sources.sh (a76f55d7d397)
 
 2009-03-27 LEMON joins to the COIN-OR initiative
@@ -41,52 +155,4 @@
         development of open-source software for the operations research
         community.
-
-2009-03-26 Version 1.0.3 released
-
-        Bugfix release, mainly targeting better AIX/xlC and WIN32
-        compatibility.
-
-        ----: Minor clarification in the LICENSE file
-        ----: Add missing unistd.h include to time_measure.h
-        #204: Compilation bug fixed in graph_to_eps.h with VS2005
-        #214,#215: windows.h is never be included by lemon headers
-        #230: Build systems check the availability of 'long long' type
-        #229: Default implementation of Tolerance<> is used for integer types
-        #211,#212: Various fixes for compiling on AIX
-        ----: Improvements in CMAKE config
-              - docs is installed in share/doc/
-              - detects newer versions of Ghostscript
-        #239: Fix missing 'inline' specifier in time_measure.h
-        
-2009-01-23 Version 1.0.2 released
-
-        Bugfix release.
-
-        #193: Bugfix in GraphReader::skipSection()
-        #195: Bugfix in ConEdgeIt()
-        #197: Bugfix in heap unionfind
-              * This bug affects Edmond's general matching algorithms.
-                (Not available in this release.)
-        #207: Fix 'make install' without 'make html' using CMAKE
-        #208: Suppress or fix VS2008 compilation warnings
-        ----: Update the LEMON icon
-        ----: Enable the component-based installer
-              (in installers made by CPACK)
-        ----: Set the proper version for CMAKE in the tarballs
-              (made by autotools).
-
-2008-12-06 Version 1.0.1 released
-
-        Bugfix release.
-
-        #170: Bugfix SmartDigraph::split()
-        #171: Bugfix in SmartGraph::restoreSnapshot()
-        #172: Extended test cases for graphs and digraphs
-        #173: Bugfix in Random
-              * operator()s always return a double now
-              * the faulty real<Num>(Num) and real<Num>(Num,Num)
-                have been removed
-        #187: Remove DijkstraWidestPathOperationTraits
-        #61:  Bugfix in DfsVisit
 
 2008-10-13 Version 1.0 released