Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 1043)
+++ doc/groups.dox	(revision 1151)
@@ -84,4 +84,9 @@
 
 /**
+@defgroup exceptions Exceptions
+This group contains the exceptions thrown by LEMON library
+*/
+
+/**
 @defgroup misc Miscellaneous Tools
 Here you can find several useful tools for development,
@@ -117,2 +122,3 @@
 The stuff here is subject to change.
 */
+
Index: src/lemon/concept/path.h
===================================================================
--- src/lemon/concept/path.h	(revision 986)
+++ src/lemon/concept/path.h	(revision 1151)
@@ -18,4 +18,6 @@
 ///\file
 ///\brief Classes for representing paths in graphs.
+///
+///\todo Iterators have obsolete style
 
 #ifndef LEMON_CONCEPT_PATH_H
@@ -99,5 +101,4 @@
        * \brief Iterator class to iterate on the edges of the paths
        *
-       * \ingroup concept
        * This class is used to iterate on the edges of the paths
        *
@@ -132,5 +133,4 @@
        * \brief Iterator class to iterate on the nodes of the paths
        *
-       * \ingroup concept
        * This class is used to iterate on the nodes of the paths
        *
@@ -167,5 +167,4 @@
        * \brief Class to build paths
        *
-       * \ingroup concept
        * This class is used to fill a path with edges.
        *
Index: src/lemon/dijkstra.h
===================================================================
--- src/lemon/dijkstra.h	(revision 1132)
+++ src/lemon/dijkstra.h	(revision 1151)
@@ -31,7 +31,5 @@
 
 
-/// \addtogroup flowalgs
-/// @{
-
+  
   ///Default traits class of Dijkstra class.
 
@@ -130,4 +128,5 @@
   ///%Dijkstra algorithm class.
   
+  /// \ingroup flowalgs
   ///This class provides an efficient implementation of %Dijkstra algorithm.
   ///The edge lengths are passed to the algorithm using a
@@ -497,5 +496,5 @@
     }
     
-    void processNode()
+    void processNextNode()
     {
       Node v=_heap.top(); 
@@ -541,5 +540,5 @@
     void start()
     {
-      while ( !_heap.empty() ) processNode();
+      while ( !_heap.empty() ) processNextNode();
     }
     
@@ -560,5 +559,5 @@
     void start(Node dest)
     {
-      while ( !_heap.empty() && _heap.top()!=dest ) processNode();
+      while ( !_heap.empty() && _heap.top()!=dest ) processNextNode();
       if ( _heap.top()==dest ) finalizeNodeData(_heap.top());
     }
@@ -576,5 +575,5 @@
     void start(const NM &nm)
     {
-      while ( !_heap.empty() && !mn[_heap.top()] ) processNode();
+      while ( !_heap.empty() && !mn[_heap.top()] ) processNextNode();
       if ( !_heap.empty() ) finalizeNodeData(_heap.top());
     }
@@ -696,6 +695,8 @@
   /// Default traits used by \ref DijkstraWizard
 
-  /// To make it easier to use Dijkstra algorithm we have created a wizard class.
-  /// This \ref DijkstraWizard class needs default traits, as well as the \ref Dijkstra class.
+  /// To make it easier to use Dijkstra algorithm
+  ///we have created a wizard class.
+  /// This \ref DijkstraWizard class needs default traits,
+  ///as well as the \ref Dijkstra class.
   /// The \ref DijkstraWizardBase is a class to be the default traits of the
   /// \ref DijkstraWizard class.
@@ -745,13 +746,17 @@
   /// A class to make easier the usage of Dijkstra algorithm
 
+  /// \ingroup flowalgs
   /// This class is created to make it easier to use Dijkstra algorithm.
   /// It uses the functions and features of the plain \ref Dijkstra,
-  /// but it is much more simple to use it.
+  /// but it is much simpler to use it.
   ///
   /// Simplicity means that the way to change the types defined
   /// in the traits class is based on functions that returns the new class
-  /// and not on templatable built-in classes. When using the plain \ref Dijkstra
-  /// the new class with the modified type comes from the original class by using the ::
-  /// operator. In the case of \ref DijkstraWizard only a function have to be called and it will
+  /// and not on templatable built-in classes.
+  /// When using the plain \ref Dijkstra
+  /// the new class with the modified type comes from
+  /// the original class by using the ::
+  /// operator. In the case of \ref DijkstraWizard only
+  /// a function have to be called and it will
   /// return the needed class.
   ///
@@ -899,4 +904,5 @@
   ///\e
 
+  /// \ingroup flowalgs
   ///\todo Please document...
   ///
Index: src/lemon/error.h
===================================================================
--- src/lemon/error.h	(revision 1125)
+++ src/lemon/error.h	(revision 1151)
@@ -18,5 +18,5 @@
 #define LEMON_ERROR_H
 
-//! \ingroup misc
+//! \ingroup exceptions
 //! \file
 //! \brief Basic exception classes and error handling.
@@ -31,4 +31,7 @@
 
 namespace lemon {
+
+/// \addtogroup exceptions
+/// @{
 
   /// Exception-safe convenient "error message" class.
@@ -334,4 +337,5 @@
   }
 
+/// @}
 
 }
Index: src/lemon/path.h
===================================================================
--- src/lemon/path.h	(revision 986)
+++ src/lemon/path.h	(revision 1151)
@@ -34,4 +34,6 @@
 ///\file
 ///\brief Classes for representing paths in graphs.
+///
+///\todo Iterators have obsolete style
 
 #ifndef LEMON_PATH_H
@@ -158,5 +160,4 @@
      * \brief Iterator class to iterate on the edges of the paths
      *
-     * \ingroup paths
      * This class is used to iterate on the edges of the paths
      *
@@ -205,5 +206,4 @@
      * \brief Iterator class to iterate on the nodes of the paths
      *
-     * \ingroup paths
      * This class is used to iterate on the nodes of the paths
      *
@@ -256,5 +256,4 @@
      * \brief Class to build paths
      *
-     * \ingroup paths
      * This class is used to fill a path with edges.
      *
@@ -495,5 +494,4 @@
      * \brief Iterator class to iterate on the edges of the paths
      *
-     * \ingroup paths
      * This class is used to iterate on the edges of the paths
      *
@@ -543,5 +541,4 @@
      * \brief Iterator class to iterate on the nodes of the paths
      *
-     * \ingroup paths
      * This class is used to iterate on the nodes of the paths
      *
@@ -596,5 +593,4 @@
      * \brief Class to build paths
      *
-     * \ingroup paths
      * This class is used to fill a path with edges.
      *